﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Bezier2
{
 public partial class Page : UserControl
 {
  Rectangle[] tabMarques;
  Point PosPrec;
  int nMarqueDéplacée = -1;  // quelle marque est déplacée
  public Page()
  {
   InitializeComponent();
  }

  private void Canvas_Loaded(object sender, RoutedEventArgs e)
  {
   tabMarques = new Rectangle[4];
   tabMarques[0] = M0; tabMarques[1] = M1; tabMarques[2] = M2; tabMarques[3] = M3;
   for (int i = 0; i < tabMarques.Length; i++)
   {
    tabMarques[i].MouseLeftButtonDown+=new MouseButtonEventHandler(Marques_MouseLeftButtonDown); 
    tabMarques[i].MouseMove+=new MouseEventHandler(Marques_MouseMove); 
    tabMarques[i].MouseLeftButtonUp+=new MouseButtonEventHandler(Marques_MouseLeftButtonUp);  
   }
   DisplayParameters();
  }
  void Marques_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    Point p = e.GetPosition(this);
    string s = r.Name.Substring(1);
    int nMarque = Int32.Parse(s);
    nMarqueDéplacée = nMarque;
    PosPrec = p;
    tabMarques[nMarque].CaptureMouse();
   }
  }
  void Marques_MouseMove(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    // one f our 4 marks, which one ?
    string s = r.Name.Substring(1);
    int nMark = Int32.Parse(s);
    if (nMarqueDéplacée == nMark)
    {
     double deltaX, deltaY;
     Point p = e.GetPosition(this);
     deltaX = p.X - PosPrec.X;
     deltaY = p.Y - PosPrec.Y;
     double X = (double)tabMarques[nMark].GetValue(Canvas.LeftProperty);
     double Y = (double)tabMarques[nMark].GetValue(Canvas.TopProperty);
     tabMarques[nMark].SetValue(Canvas.LeftProperty, X + deltaX);
     tabMarques[nMark].SetValue(Canvas.TopProperty, Y + deltaY);
     PosPrec = p;
     // create the updated Bezier curve
     Figs.Segments.Clear();
     BezierSegment bs = new BezierSegment();
     Point[] tP = new Point[4];
     for (int i = 0; i < tP.Length; i++)
     {
      tP[i].X = (double)tabMarques[i].GetValue(Canvas.LeftProperty) + 5;
      tP[i].Y = (double)tabMarques[i].GetValue(Canvas.TopProperty) + 5;
     }
     bs.Point1 = tP[1];
     bs.Point2 = tP[2];
     bs.Point3 = tP[3];
     Figs.StartPoint = tP[0];
     Figs.Segments.Add(bs);
     DisplayParameters();
    }
   }
  }

  void Marques_MouseLeftButtonUp(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    // which mark ?
    string s = r.Name.Substring(1);
    int nMark = Int32.Parse(s);
    nMarqueDéplacée = -1;
    tabMarques[nMark].ReleaseMouseCapture();
   }
  }

  void DisplayParameters()
  {
   Point[] tP = new Point[4];
   for (int i = 0; i < tP.Length; i++)
   {
    tP[i].X = (double)tabMarques[i].GetValue(Canvas.LeftProperty) + 5;
    tP[i].Y = (double)tabMarques[i].GetValue(Canvas.TopProperty) + 5;
   }
   tbStPt.Text = tP[0].X + " - " + tP[0].Y;
   tbEndPt.Text = tP[3].X + " - " + tP[3].Y;
   tbCtrlPt1.Text = tP[1].X + " - " + tP[1].Y;
   tbCtrlPt2.Text = tP[2].X + " - " + tP[2].Y;
  }
 }
}
